import Context from "./Context";
import { Message } from "discord.js";
import ICommandList from "../Interfaces/ICommandList";
import CommandList from "../Models/CommandList";
import IProcessor from "../Interfaces/IProcessor";
import { ILogsModel } from "../Database/Models/Logs";
export default class Processor implements IProcessor {
    static DELAY_TIMER: number;
    Commands: CommandList;
    Context: Context;
    DbInUse: boolean;
    Loaded: boolean;
    Logging: number;
    Prefix: string;
    constructor(context: Context, prefix?: string, logging?: number);
    private LoadCommandsLocal;
    private LoadCommandsFromDatabase;
    private formatCommandSignatures;
    private GetCommandSignatures;
    HelpCommand(message: Message): Promise<Message | Message[]>;
    LoadCommands(Commands: any, useDB: boolean): Promise<ICommandList>;
    SaveLogs(log: ILogsModel): Promise<boolean>;
    Handle(message: Message): Promise<any>;
}
